--[[
	Stuff for FA+ Display is contained in this script
]]

-- Set up mod table and variables
FAPlusDisplay = {}
for i = 1,2 do
	FAPlusDisplay[i] = {
		Percentage = false,
		PlusCount = false,
		MinusCount = false,
		SubCount = false
	}
end
FAPlusTarget = 90 -- Change this if you want the "green" threshold to be different.

-- Option row
table.insert(playerOptions[2],"FAPlusDisplay")
function FAPlusDisplayOption()
	local t = CustomMod('FA+ Display','FAPlusDisplay',{"Percentage","F+ Count","F- Count","Sub-F Count"})
	t.OneChoiceForAllPlayers = false
	t.SelectType = "SelectMultiple"
	t.LoadSelections = function(self, list, pn)
		--if FAPlusDisplay[pn+1] then list[2] = true else list[1] = true end
		local keys = {"Percentage","PlusCount","MinusCount","SubCount"}
		for i,v in ipairs(keys) do
			list[i] = FAPlusDisplay[pn+1][v]
		end
	end
	t.SaveSelections = function(self, list, pn)
		--FAPlusDisplay[pn+1] = list[2]
		local keys = {"Percentage","PlusCount","MinusCount","SubCount"}
		for i,v in ipairs(keys) do
			FAPlusDisplay[pn+1][v] = list[i]
		end
	end
	return t
end
ModsMaster.FAPlusDisplay = { fnctn = 'FAPlusDisplayOption' }